<?xml version="1.0" encoding="utf-8"?>
<layout xmlns:android="http://schemas.android.com/apk/res/android"
        xmlns:tools="http://schemas.android.com/tools"
        xmlns:bind="http://schemas.android.com/apk/res-auto"
        xmlns:app="http://schemas.android.com/apk/res-auto"
        tools:context=".MainActivity">

    <data>
        <import type="com.oasisfeng.island.model.AppViewModel.State" />
        <import type="android.view.View" />
        <import type="com.google.android.material.bottomsheet.BottomSheetBehavior" />
        <import type="com.oasisfeng.island.mobile.BuildConfig" />
        <variable name="apps" type="com.oasisfeng.island.model.AppListViewModel" />
        <variable name="featured" type="com.oasisfeng.island.featured.FeaturedListViewModel" />
        <variable name="card" type="com.oasisfeng.ui.card.CardViewModel" />
        <variable name="guide" type="com.oasisfeng.island.guide.UserGuide" />
    </data>

    <androidx.coordinatorlayout.widget.CoordinatorLayout android:layout_width="match_parent" android:layout_height="match_parent" >

        <com.google.android.material.appbar.AppBarLayout
            android:id="@+id/top_bar"
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:background="@color/background">

            <Toolbar
                android:id="@+id/actionbar"
                android:layout_width="match_parent"
                android:layout_height="?android:attr/actionBarSize"
                android:background="?android:attr/colorPrimary"
                android:elevation="4dp"
                android:theme="@android:style/ThemeOverlay.Material.Dark.ActionBar"
                android:popupTheme="@style/AppThemeOverlay.Dark.Popup" />

            <com.google.android.material.chip.ChipGroup
                android:id="@+id/chips"
                android:background="@color/header_background"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:paddingTop="@dimen/margin_small"
                android:paddingBottom="@dimen/margin_small"
                android:paddingStart="@dimen/margin_medium"
                android:paddingEnd="@dimen/margin_medium"
                app:chipSpacingHorizontal="@dimen/margin_medium"
                app:chipSpacingVertical="0dp"
                bind:shown="@{apps.mChipsVisible &amp;&amp; ! featured.visible}">

                <com.google.android.material.chip.Chip
                    style="@style/Widget.MaterialComponents.Chip.Filter"
                    android:layout_width="wrap_content"
                    android:layout_height="wrap_content"
                    app:chipStrokeColor="@color/accent"
                    app:chipIconTint="@color/accent"
                    app:chipStrokeWidth="2dp"
                    app:checkedIconVisible="false"
                    app:chipBackgroundColor="@color/chip_background_color"
                    app:rippleColor="@color/accent"
                    android:checked="@={apps.getFilterIncludeHiddenSystemApps()}"
                    android:text="@string/filter_include_hidden_system_components" />

                <com.google.android.material.chip.Chip
                    style="@style/Widget.MaterialComponents.Chip.Entry"
                    android:layout_width="wrap_content"
                    android:layout_height="wrap_content"
                    android:checkable="false"
                    app:chipStrokeColor="@color/primary"
                    app:chipStrokeWidth="2dp"
                    app:chipBackgroundColor="@color/chip_background_color"
                    bind:shown="@{! apps.getFilterText().isEmpty()}"
                    bind:onCloseIconClickListener="@{view -> apps.onQueryTextCleared()}"
                    tools:text="@{apps.getFilterText()}" />

            </com.google.android.material.chip.ChipGroup>

            <com.google.android.material.tabs.TabLayout
                android:id="@+id/tabs"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:layout_gravity="top"
                bind:tabInlineLabel="true"
                bind:tabSelectedTextColor="@color/textPrimary"
                bind:tabMode="scrollable" />

        </com.google.android.material.appbar.AppBarLayout>

        <androidx.recyclerview.widget.RecyclerView
            android:id="@+id/app_list"
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            app:layout_behavior="@string/appbar_scrolling_view_behavior"
            android:paddingBottom="88dp"
            android:paddingStart="-16dp" tools:comment="To workaround the weired tilt side shadow on elevated item"
            android:paddingEnd="-16dp"
            android:clipToPadding="false"
            android:background="@color/background"
            app:layoutManager="androidx.recyclerview.widget.LinearLayoutManager"
            bind:shown="@{! featured.visible}"
            bind:items="@{apps.items}"
            bind:item_binder="@{apps.item_binder}"
            bind:item_layout="@{@layout/app_entry}"
            tools:listitem="@layout/app_entry" /> <!-- "paddingBottom" should be no less than "behavior_peekHeight" of bottom sheet. -->

        <androidx.recyclerview.widget.RecyclerView
            android:id="@+id/featured_list"
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            app:layout_behavior="@string/appbar_scrolling_view_behavior"
            bind:shown="@{featured.visible}"
            android:paddingBottom="88dp"
            android:clipToPadding="false"
            android:background="@color/background"
            app:layoutManager="androidx.recyclerview.widget.LinearLayoutManager"
            bind:items="@{featured.features}"
            bind:item_binder="@{featured.item_binder}"
            bind:item_layout="@{@layout/featured_entry}"
            bind:item_touch="@{featured.item_touch_helper}"
            tools:listitem="@layout/app_entry" />

        <TextView
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            android:gravity="center"
            bind:shown="@{! featured.visible &amp;&amp; apps.items.isEmpty()}"
            android:textAppearance="?android:textAppearanceLarge"
            android:fontFamily="sans-serif-condensed"
            android:lineSpacingMultiplier="1.3"
            android:text="@string/tip_empty_app_list" />

        <ViewStub
            android:id="@+id/tip"
            android:layout="@layout/card"
            android:layout_marginTop="?android:attr/actionBarSize"
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:visibility="@{card != null ? View.VISIBLE : View.GONE}"
            bind:vm="@{card}" />

        <LinearLayout
            android:orientation="vertical"
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:paddingBottom="16dp"
            android:theme="@style/AppTheme.Dark"
            android:background="?android:attr/colorPrimaryDark"
            android:elevation="@dimen/elevation_card_raised"
            app:layout_behavior="com.google.android.material.bottomsheet.BottomSheetBehavior"
            app:behavior_hideable="true"
            app:behavior_peekHeight="80dp"
            bind:behavior_state="@{apps.mSelection != null ? BottomSheetBehavior.STATE_COLLAPSED : BottomSheetBehavior.STATE_HIDDEN}"
            bind:behavior_bottomSheetCallback="@{apps.bottom_sheet_callback}"
            android:onClick="@{apps::onBottomSheetClick}">

            <Toolbar
                android:id="@+id/toolbar"
                android:layout_width="match_parent"
                android:layout_height="?android:attr/actionBarSize"
                android:background="?android:attr/colorPrimaryDark"
                android:theme="@android:style/ThemeOverlay.Material.Dark.ActionBar"
                android:popupTheme="@style/AppThemeOverlay.Dark.Popup"
                android:title="@{apps.mSelection.info.label}" tools:title="Island"
                bind:menu="@{apps.actions_menu}"
                android:onMenuItemClick="@{item -> apps.onActionClick(context, item)}"
                android:prompt="@{guide.prompt_action}"/>

            <TextView
                android:id="@+id/summary"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:paddingStart="@dimen/margin_medium"
                android:paddingEnd="@dimen/margin_medium"
                android:textAppearance="?android:attr/textAppearanceSmall"
                android:text="@{apps.mSelection.getStatusText(context)}" tools:text="Frozen"/>

            <TextView
                android:id="@+id/package_name"
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:paddingStart="@dimen/margin_medium"
                android:paddingEnd="@dimen/margin_medium"
                android:paddingTop="@dimen/margin_small"
                android:textAppearance="?android:attr/textAppearanceSmall"
                android:text="@{@string/field_app_id(apps.mSelection.info.packageName)}" tools:text="APP ID: com.oasisfeng.island"/>

        </LinearLayout>

    </androidx.coordinatorlayout.widget.CoordinatorLayout>

</layout>